# Documentation

Welcome to the ACE docs! If you're interested in something and it's not covered
here, or you have a hard time understanding something, please submit an issue.
We want to keep those docs as elaborate and easy to understand as possible.

## Installing

- [Compiler setup](installing/compiler.md)
- [Building ACE](installing/ace.md)
- [Building tools](installing/tools.md)

## Tutorial

1. [ACE in a nutshell](programming/ace_in_a_nutshell.md)
1. [Hello World example](programming/hello_world.md)
1. [View & viewports explained](programming/view.md)
1. [Blitter](programming/blit.md)
1. [Moving blitted objects](programming/moving_blits.md)
1. [Loading images and displaying background](programming/loading_images.md)
1. [Handling blitted object undraw](programming/blit_undraw.md)
1. [Blitting with masks](programming/blits_with_mask.md)
1. Fonts
1. Optimizing blits
1. Audio
1. Debugging memory leaks
1. Organizing your project
1. Copperlists
1. Double buffering
1. [Sprites](programming/sprites.md)
1. [Working with and without OS](programming/os.md)
1. DMA usage

## Reference manual

TBD, will be doxy-generated or done as wiki pages, idk yet.

## Conversion tools

- Pallettes
- [Bitmaps](tools/bitmap_conv.md)
- Fonts

## Contributing

- [Code style](contributing/codestyle.md)
